'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var umi = require('@metaplex-foundation/umi');
var sha512 = require('@noble/hashes/sha512');

const createDerivedSigner = async (context, originalSigner, message) => {
  const messageBytes = typeof message === 'string' ? umi.utf8.serialize(message) : message;
  const signature = await originalSigner.signMessage(messageBytes);
  const seeds = sha512.sha512(signature).slice(0, 32);
  const keypair = context.eddsa.createKeypairFromSeed(seeds);
  return {
    ...umi.createSignerFromKeypair(context, keypair),
    originalSigner
  };
};
const isDerivedKeypair = signer => signer.originalSigner !== undefined && umi.isKeypairSigner(signer);

exports.createDerivedSigner = createDerivedSigner;
exports.isDerivedKeypair = isDerivedKeypair;
//# sourceMappingURL=DerivedSigner.cjs.map
